/* str.h -- header for str.c.

   Copyright (C) 1997 Free Software Foundation, Inc.
   Written by Thomas Morgan <tmorgan@gnu.ai.mit.edu>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>

/* Always add at least this many bytes when extending the buffer.  */
#define CHUNK 64

/* Return values for str_add_line.  */
enum add_line_return
  {
    ADD_LINE_OK,
    ADD_LINE_ERR,
    ADD_LINE_EOF
  };

struct str
  {
    char *str;			/* The array of characters.  */
    int len;			/* The number of characters.  */
    size_t mem;			/* The amount of memory allocated.  */
  };
typedef struct str str_t;

#ifndef PARAMS
#if PROTOTYPES
#define PARAMS(x) x
#else /* ! PROTOTYPES */
#define PARAMS(x) ()
#endif /* __STDC__ */
#endif /* ! PARAMS */

char *str_to_nstr PARAMS ((str_t * str));
int str_add_line PARAMS ((str_t *, FILE *));
int str_add_line_from_desc PARAMS ((str_t *, int));
str_t *int_to_str PARAMS ((int));
str_t *nstr_to_str PARAMS ((char *));
str_t *str_make PARAMS ((str_t *));
void str_add_char PARAMS ((str_t *, char));
void str_add_str PARAMS ((str_t *, str_t *));
